require_dependency "skirental_frontend_api/application_controller"

module SkirentalFrontendApi
    class BookingsController < ApplicationController
        def context
            booking = Booking.where(shop_id:  booking_params[:shop_id]).first
            render json: booking
        end

        def create
            new_booking = Booking.new(shop_id: booking_params[:shop_id], session_id: booking_params[:session_id], context: booking_params[:context].to_h)
            if new_booking.save
                render json: { error: "" }, :status => :created
            else
                render json: { error: new_booking.errors.full_messages }, :status => :unprocessable_entity
            end

        end

        def update
            booking = Booking.where(shop_id:  booking_params[:shop_id]).first

            if booking.nil?
                render json: { error: "not found"}, :status => :not_found
            else
                booking.context = booking_params[:context].to_h
                if booking.save
                    render json: { error: "" }, :status => :created
                else
                    render json: { error: booking.errors.full_messages }, :status => :unprocessable_entity
                end
            end
        end

        private

        def booking_params
            params.permit(:shop_id, :session_id, context: {})
        end
    end
end
